///////////////////////////////////////////////////////////////////
//Aufgabe 1 Kapitel Game of Life
//////////////////////////////////////////////////////////////////////

int[] regelWerk ;  //Startregelwerk
int[] zellen;
int breite,hoehe;
int q; //Seitenlänge gezeichnetes Quadrat
int generation = 0;//aktuelle zu zeichnende Generation


void setup() {
  breite = 1000;
  hoehe  = 600;
  surface.setSize(breite,hoehe);  
  background(255);
  //frameRate(10);//Um genauer beobachten zu können...
  regelWerk = new int[32];
  zufallRegelwerk();
  println(regelWerk);
  q = 2;
  zellen = new int[breite/q];
  neuStart();
}

void draw(){
 for (int i = 0; i < zellen.length; i++) {
    if (zellen[i] == 0) fill(255);
    if (zellen[i] == 1) fill(0);
    
    noStroke();
    rect(i*q, generation*q, q, q);
  }
  zellenErzeugen();
  naechsteGenerationErzeugen();
  if (generation == hoehe/q-5)noLoop();
}

void zellenErzeugen(){
   int[] naechsteGeneration = new int[zellen.length];
   for (int i = 2; i < zellen.length-2; i++) {
      int linkeAZ  = zellen[i-2];   // Zustand links außen
      int linkeZ   = zellen[i-1];   // Zustand linker Nachbar
      int mittlereZ = zellen[i];    // Zustand selbst
      int rechteZ   = zellen[i+1];  // Zustand rechter Nachbar
      int rechteAZ  = zellen[i+2];  // Zustand rechts außen
      // nächste Generation mit Regelwerk erstellen
      naechsteGeneration[i] = regeln(linkeAZ, linkeZ, mittlereZ, rechteZ,rechteAZ); 
    }
}

int regeln (int linksA, int links, int mitte, int rechts, int rechtsA) {
    int regelNummer =16*linksA+8*links+ 4*mitte+2*rechts+rechtsA;  //Regelnummer ins 10-er System 
    return regelWerk[regelNummer] ;
  }
 
void naechsteGenerationErzeugen(){
  int[] naechsteGeneration = new int[zellen.length];//leeren Int-Array erzeugen
   // Mit Regelwerk nächste Generation berechnen
   // Ränder werden nicht beachtet
   for (int i = 2; i < zellen.length-2; i++) {
      int linksA = zellen[i-2];   
      int links   = zellen[i-1];   
      int mitte   = zellen[i];       
      int rechts  = zellen[i+1];  
      int rechtsA = zellen[i+2];  
      naechsteGeneration[i] = regeln(linksA,links, mitte,rechts,rechtsA); 
   }
   zellen = naechsteGeneration;
   generation++;
}

void neuStart(){
  for (int i = 0; i < zellen.length; i++) {
      zellen[i] = 0;
    }
  // Mittlere Zelle der 0.ten Generation bekommt eine 1 und ist somit grün
  zellen[zellen.length/2] = 1;   
  generation = 0;
}

void mousePressed() {
  background(255);
  zufallRegelwerk();
  neuStart();
  loop();
}
//Es gibt etwa 4,3 Milliarden verschiedene Regelwerke! (2 hoch 32)
void zufallRegelwerk(){
  for (int i = 0; i < 32; i++) {
      regelWerk[i] = int(random(2));
  }
  println(regelWerk);println(); //Zur Information
}